
/*
 * Entry - encapsulates an Address Book entry (i.e., an Address
 * Book record or row)
 */


import java.net.URL;
import java.sql.*;


public class Entry
{
	public String id;
	public String first_name;
	public String last_name;
	public String title;
	public String company;
	public String e_mail;

	public Entry()
	{
		emptyEntry();
	}
	public Entry(Connection con, String myId)
		   throws java.sql.SQLException
	{
		emptyEntry();
		id = myId;

		if (myId.length() > 0) {
			Statement stmt = con.createStatement();
			ResultSet res = stmt.executeQuery(
				"SELECT id, company, first_name, last_name, title, e_mail "
				+ "FROM addr_book "
				+ "WHERE id = " + myId
			);

			if (res.next()) {
				entryFromRow(res);
			}

			stmt.close();
		}
	}
	public Entry (ResultSet res)
		   throws java.sql.SQLException
	{
		entryFromRow(res);
	}
	public static void delete(Connection con, String id)
			throws java.sql.SQLException
	{
		Statement stmt = con.createStatement ();

		stmt.executeUpdate(
			"DELETE FROM addr_book "
			+ "WHERE id = " + id
		);
	}
	protected void emptyEntry()
	{
		id = "";
		first_name = "";
		last_name = "";
		title = "";
		company = "";
		e_mail = "";
	}
	private void entryFromRow (ResultSet res)
		   throws java.sql.SQLException
	{
		/*
		 * As we are inserting spaces instead of empty strings or
		 * NULL values, we need to remove these extra spaces.
		 * THIS IS A HACK!
		 */
		id = res.getString("id");
		last_name = res.getString("last_name").trim();
		first_name = res.getString("first_name").trim();
		company = res.getString("company").trim();
		title = res.getString("title").trim();
		e_mail = res.getString("e_mail").trim();
	}
	public void insert(Connection con)
		   throws java.sql.SQLException
	{
		Statement stmt = con.createStatement ();

		ResultSet res = stmt.executeQuery("SELECT _seq FROM addr_book");
		res.next();
		id = res.getString("_seq");

		stmt.executeUpdate(
			"INSERT INTO addr_book "
			+ "(id, first_name, last_name, title, company, e_mail) "
			+ "VALUES (" + id + ", "
			+ "'" + first_name +"', '" + last_name + "', "
			+ "'" + title +"', '" + company + "', "
			+ "'" + e_mail +"')"
		);
		stmt.close();
	}
	public void update(Connection con)
			   throws java.sql.SQLException
	{
		Statement stmt = con.createStatement ();
		stmt.executeUpdate(
			"UPDATE addr_book SET "
			+ "first_name = '" + first_name + "', "
			+ "last_name = '" + last_name + "', "
			+ "title = '" + title + "', "
			+ "company = '" + company + "', "
			+ "e_mail = '" + e_mail + "' "
			+ "WHERE id = " + id
		);
		stmt.close();
	}
	public void validate()
				throws java.lang.Exception
	{
		if (last_name.length() == 0 || e_mail.length() == 0) {
			Exception e = new Exception(
				"You should provide at least "
				+ "a last name and an e-mail"
			);
			throw(e);
		}

		/*
		 * mSQL JDBC driver gets lost if it gets an empty string
		 * from the database and you get no rows. THIS IS A HACK!
		 * The correct solution would be to insert NULL values for
		 * the empty fields
		 */
		 if (first_name.length() == 0) first_name = " ";
		 if (title.length() == 0) title = " ";
		 if (company.length() == 0) company = " ";
	}
}